//----------------------------------------------------------------------------
// DMailboxes.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: DMailboxes.pas
//----------------------------------------------------------------------------
#ifndef DMailboxesHPP
#define DMailboxesHPP
//----------------------------------------------------------------------------
#include <msmsg.hpp>
#include <Forms.hpp>
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <System.hpp>
namespace Dmailboxes
{
//-- type declarations -------------------------------------------------------
enum TMailBoxFlagItem { Noinferiors, Noselect, Unmarked, Marked };

typedef Set<TMailBoxFlagItem, Noinferiors, Marked>  TMailBoxFlag;

enum TMailBoxType { mtOther, mtInbox, mtOutBox, mtTrash };

enum TMessageFlag { mesSeen, mesAnswered, mesFlagged, mesDeleted, mesDraft, mesRecent, mesCustom, mesMDNSent 
	};

typedef Set<TMessageFlag, mesSeen, mesMDNSent>  TMessageFlagSet;

typedef System::TMetaClass*TCustomMessageClass;

enum TMailboxState { mbxNormal, mbxSynchronizing, mbxNew };

class __declspec(delphiclass) TamListMessage;
class __declspec(pascalimplementation) TamListMessage : public Msmsg::TmsMessage
{
	typedef Msmsg::TmsMessage inherited;
	
__published:
	__fastcall virtual TamListMessage(Classes::TComponent* AOwner);
	__fastcall virtual ~TamListMessage(void);
};

class __declspec(delphiclass) TamMessageList;
class __declspec(pascalimplementation) TamMessageList : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	TamListMessage* __fastcall GetItem(int Index);
	void __fastcall SetItem(int Index, TamListMessage* Value);
	int __fastcall GetCount(void);
	
protected:
	Classes::TList* FList;
	
public:
	__fastcall virtual TamMessageList(Classes::TComponent* AOwner);
	__fastcall virtual ~TamMessageList(void);
	int __fastcall Find(TamListMessage* Item);
	int __fastcall Add(TamListMessage* Value);
	void __fastcall Clear(void);
	virtual void __fastcall Delete(int Index);
	HIDESBASE int __fastcall Remove(TamListMessage* Value);
	__property int Count = {read=GetCount, nodefault};
	__property TamListMessage* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
};

class __declspec(delphiclass) TMailBox;
class __declspec(delphiclass) TMailboxList;
class __declspec(pascalimplementation) TMailboxList : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	Classes::TList* FList;
	System::AnsiString FOfficeLocation;
	System::AnsiString FUserName;
	TMailBox* __fastcall GetItem(int Index);
	int __fastcall GetCount(void);
	TMailBox* __fastcall GetItemByName( System::AnsiString Value);
	
protected:
	virtual void __fastcall SetOfficeLocation( System::AnsiString Value);
	void __fastcall RenameChildMailboxes( System::AnsiString OldName, TMailBox* MailBox);
	
public:
	__fastcall virtual TMailboxList(Classes::TComponent* AOwner);
	__fastcall TMailboxList(void);
	__fastcall virtual ~TMailboxList(void);
	int __fastcall Add(TMailBox* Value);
	void __fastcall Clear(void);
	void __fastcall Delete(int Index);
	void __fastcall DeleteByName( System::AnsiString Name);
	TMailBox* __fastcall FindMailboxByName( System::AnsiString Name);
	TMailBox* __fastcall FindMailBox( System::AnsiString Name, bool IsLocalStored);
	TMailBox* __fastcall CreateLocalMailBox( System::AnsiString Name);
	void __fastcall Rename( System::AnsiString NewName, TMailBox* MailBox);
	TMailBoxFlag __fastcall ObtainAttributes( System::AnsiString MailboxName);
	virtual void __fastcall Open(void);
	virtual void __fastcall Save(void);
	__property int Count = {read=GetCount, nodefault};
	__property TMailBox* Items[int Index] = {read=GetItem};
	__property TMailBox* ItemsByName[System::AnsiString Name] = {read=GetItemByName/*, default*/};
	
__published:
	__property System::AnsiString OfficeLocation = {read=FOfficeLocation, write=SetOfficeLocation, nodefault
		};
	__property System::AnsiString UserName = {read=FUserName, write=FUserName, nodefault};
};

class __declspec(delphiclass) TmsImapMessage;
class __declspec(pascalimplementation) TMailBox : public TamMessageList
{
	typedef TamMessageList inherited;
	
private:
	TMailboxState FState;
	System::AnsiString FName;
	System::AnsiString FCaption;
	System::ShortString FDelimiter;
	System::AnsiString FAdditionalFlags;
	TMessageFlagSet FParsedFlags;
	TMailBoxFlag FAttributes;
	System::AnsiString FPermanentFlags;
	bool FIsLocal;
	bool FAutoSaveOnDestroy;
	TMailBoxType FMailBoxType;
	long FUIDVALIDITY;
	long FFirstUnseen;
	long FTotal;
	bool FSubscribed;
	long FRecent;
	TMailboxList* FAllMailboxes;
	
protected:
	long FUnSeen;
	long FUIDNext;
	HIDESBASE virtual void __fastcall SetName( System::AnsiString Value);
	void __fastcall RemoveLinkToMessage(TmsImapMessage* Value);
	virtual void __fastcall SetAllMailboxes(TMailboxList* Value);
	void __fastcall ClearCached(void);
	virtual void __fastcall SetUIDValidity(long Value);
	virtual void __fastcall SetUnseen(long Value);
	virtual void __fastcall SetUIDNext(long Value);
	virtual System::AnsiString __fastcall GetFlags(void);
	virtual void __fastcall SetFlags( System::AnsiString Value);
	
public:
	__fastcall virtual TMailBox(Classes::TComponent* AOwner);
	__fastcall virtual ~TMailBox(void);
	void __fastcall AppendFrom(Classes::TPersistent* Value);
	virtual void __fastcall Assign(Classes::TPersistent* Value);
	System::AnsiString __fastcall GetParentName(void);
	virtual void __fastcall Lock(void);
	virtual void __fastcall UnLock(void);
	HIDESBASE virtual int __fastcall Add(TmsImapMessage* Value);
	virtual void __fastcall DeleteByName(TmsImapMessage* Value);
	virtual void __fastcall LoadData(void);
	virtual void __fastcall SaveData(void);
	virtual void __fastcall SaveMailBoxData(void);
	virtual void __fastcall LoadMailBoxData(void);
	TmsImapMessage* __fastcall FindMessage(long MsgNo);
	TmsImapMessage* __fastcall FindMessageByUID(long UID);
	bool __fastcall StoresCustomFlags(void);
	__property TMailboxState State = {read=FState, write=FState, nodefault};
	__property long UnSeen = {read=FUnSeen, write=SetUnseen, nodefault};
	__property long UIDNext = {read=FUIDNext, write=SetUIDNext, nodefault};
	
__published:
	__property System::ShortString Delimiter = {read=FDelimiter, write=FDelimiter};
	__property System::AnsiString Name = {read=FName, write=SetName, nodefault};
	__property System::AnsiString Flags = {read=GetFlags, write=SetFlags, stored=FIsLocal, nodefault};
	__property System::AnsiString ExtentionFlags = {read=FAdditionalFlags, write=FAdditionalFlags, stored=false
		, nodefault};
	__property TMessageFlagSet ParsedFlags = {read=FParsedFlags, write=FParsedFlags, stored=false, nodefault
		};
	__property TMailBoxFlag Attributes = {read=FAttributes, write=FAttributes, nodefault};
	__property System::AnsiString PermanentFlags = {read=FPermanentFlags, write=FPermanentFlags, stored=
		FIsLocal, nodefault};
	__property bool LocalStored = {read=FIsLocal, write=FIsLocal, nodefault};
	__property bool AutoSaveOnDestroy = {read=FAutoSaveOnDestroy, write=FAutoSaveOnDestroy, nodefault};
		
	__property TMailBoxType MailBoxType = {read=FMailBoxType, write=FMailBoxType, default=0};
	__property long UIDValidity = {read=FUIDVALIDITY, write=SetUIDValidity, nodefault};
	__property long FirstUnseen = {read=FFirstUnseen, write=FFirstUnseen, nodefault};
	__property long Total = {read=FTotal, write=FTotal, nodefault};
	__property long Recent = {read=FRecent, write=FRecent, nodefault};
	__property bool Subscribed = {read=FSubscribed, write=FSubscribed, nodefault};
	__property System::AnsiString Caption = {read=FCaption, write=FCaption, nodefault};
	__property TMailboxList* AllMailboxes = {read=FAllMailboxes, write=SetAllMailboxes, nodefault};
};

enum TMessageState { msServerUpdate, msNew, msExpunged };

class __declspec(pascalimplementation) TmsImapMessage : public TamListMessage
{
	typedef TamListMessage inherited;
	
private:
	TMessageState InternalState;
	TMailBox* FMailBox;
	long FMsgNo;
	System::AnsiString FOriginalMailbox;
	System::AnsiString AdditionalFlags;
	TMessageFlagSet FServerFlags;
	System::ShortString FInternalDate;
	long FSize;
	virtual void __fastcall SetOriginalMailbox( System::AnsiString Value);
	virtual void __fastcall SetMailBox(TMailBox* Value);
	TMailboxList* __fastcall GetAllMailboxes(void);
	
protected:
	long FUID;
	virtual long __fastcall GetUID(void);
	
public:
	__fastcall virtual TmsImapMessage(Classes::TComponent* AOwner);
	__fastcall virtual ~TmsImapMessage(void);
	virtual void __fastcall Assign(Classes::TPersistent* Value);
	__property TMailBox* MailBox = {read=FMailBox, write=SetMailBox, nodefault};
	HIDESBASE void __fastcall LoadFromFile( System::AnsiString FileName);
	HIDESBASE void __fastcall SaveToFile( System::AnsiString FileName);
	void __fastcall AppendToMailbox( System::AnsiString FileName, TMailBox* MB);
	virtual System::AnsiString __fastcall GetName(void);
	virtual void __fastcall SetState(TMessageState Value);
	TMessageState __fastcall GetState(void);
	virtual void __fastcall SetServerFlags(TMessageFlagSet Value);
	virtual TMessageFlagSet __fastcall GetServerFlags(void);
	virtual System::AnsiString __fastcall GetFlags(void);
	virtual void __fastcall SetFlags( System::AnsiString Value);
	__property TMessageState State = {read=GetState, write=SetState, nodefault};
	
__published:
	__property long MsgNo = {read=FMsgNo, write=FMsgNo, nodefault};
	__property System::AnsiString OriginalMailbox = {read=FOriginalMailbox, write=SetOriginalMailbox, nodefault
		};
	__property long UID = {read=GetUID, write=FUID, nodefault};
	__property long Size = {read=FSize, write=FSize, nodefault};
	__property System::AnsiString Flags = {read=GetFlags, write=SetFlags, nodefault};
	__property System::AnsiString ExtentionFlags = {read=AdditionalFlags, write=AdditionalFlags, stored=false
		, nodefault};
	__property TMessageFlagSet ServerFlags = {read=GetServerFlags, write=SetServerFlags, stored=false, 
		nodefault};
	__property System::ShortString InternalDate = {read=FInternalDate, write=FInternalDate};
	__property TMailboxList* AllMailboxes = {read=GetAllMailboxes, nodefault};
};

//-- var, const, procedure ---------------------------------------------------
extern System::AnsiString MailboxFlagsStr[4];
extern System::AnsiString MessageFlagsStr[8];
extern TMailBoxFlag __fastcall GetMailboxFlags( System::AnsiString S);
extern TMailBoxFlag __fastcall GetMailboxFlagsEx( System::AnsiString S,  System::AnsiString &UnknownFlags
	);
extern System::AnsiString __fastcall PutMailboxFlags(TMailBoxFlag MF);
extern TMessageFlagSet __fastcall GetMessageFlags( System::AnsiString S);
extern TMessageFlagSet __fastcall GetMessageFlagsSafe( System::AnsiString S);
extern TMessageFlagSet __fastcall GetMessageFlagsEx( System::AnsiString S,  System::AnsiString &UnknownFlags
	);
extern System::ShortString __fastcall PutMessageFlags(TMessageFlagSet MF);
//-- template instantiations -------------------------------------------------
template class TMessageFlagSet ;
template class TMailBoxFlag ;

}	/* namespace Dmailboxes */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Dmailboxes;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// DMailboxes
